"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const auth0_spa_js_1 = tslib_1.__importDefault(require("@auth0/auth0-spa-js"));
const react_1 = tslib_1.__importStar(require("react"));
const auth0_context_1 = tslib_1.__importDefault(require("./auth0-context"));
const user_provider_1 = tslib_1.__importDefault(require("./user-provider"));
const auth0_1 = require("../utils/auth0");
function Auth0Provider(_a) {
    var { children, clientId, redirectUri, onRedirecting, onRedirectCallback, onLoginError, onAccessTokenError } = _a, props = tslib_1.__rest(_a, ["children", "clientId", "redirectUri", "onRedirecting", "onRedirectCallback", "onLoginError", "onAccessTokenError"]);
    const [client, setClient] = react_1.useState();
    react_1.useEffect(() => {
        const initAuth0 = () => tslib_1.__awaiter(this, void 0, void 0, function* () {
            try {
                setClient(yield auth0_spa_js_1.default(Object.assign({ client_id: clientId, redirect_uri: redirectUri }, props)));
            }
            catch (err) {
                if (onLoginError) {
                    onLoginError(err);
                }
            }
        });
        initAuth0();
    }, []);
    const value = {
        client,
        login: (opt) => auth0_1.ensureClient(client).loginWithRedirect(opt),
        logout: (opt) => auth0_1.ensureClient(client).logout(opt),
        getAccessToken: (opt) => auth0_1.ensureClient(client).getTokenSilently(opt),
        handlers: {
            onRedirecting,
            onRedirectCallback,
            onLoginError,
            onAccessTokenError
        }
    };
    return (react_1.default.createElement(auth0_context_1.default.Provider, { value: value },
        react_1.default.createElement(user_provider_1.default, null, children)));
}
exports.default = Auth0Provider;
//# sourceMappingURL=auth0-provider.js.map