"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function ensureClient(client) {
    if (!client) {
        throw new Error('Auth0Client was not initialized');
    }
    return client;
}
exports.ensureClient = ensureClient;
exports.DEFAULT_SCOPE = 'openid profile email';
const dedupe = (arr) => arr.filter((x, i) => arr.indexOf(x) === i);
function getUniqueScopes(...scopes) {
    const scopeString = scopes.filter(Boolean).join();
    return dedupe(scopeString.replace(/\s/g, ',').split(','))
        .join(' ')
        .trim();
}
exports.getUniqueScopes = getUniqueScopes;
function getAccessTokenFromCache(client, audience, scope) {
    const cacheContainer = ensureClient(client);
    const { cache } = cacheContainer;
    const token = cache.get({
        scope: getUniqueScopes(exports.DEFAULT_SCOPE, scope),
        audience: audience || 'default'
    });
    return token && token.access_token;
}
exports.getAccessTokenFromCache = getAccessTokenFromCache;
//# sourceMappingURL=auth0.js.map